package ru.dbotthepony.kstarbound.defs.item

import ru.dbotthepony.kstarbound.defs.MaterialReference
import ru.dbotthepony.kstarbound.defs.util.enrollMap
import ru.dbotthepony.kstarbound.io.json.builder.BuilderAdapter
import ru.dbotthepony.kstarbound.io.json.builder.JsonBuilder

@JsonBuilder
class MaterialItemPrototype : ItemPrototype() {
	var material: MaterialReference? = null

	var materialId: Int?
		get() = material?.id
		set(value) {
			if (material == null)
				material = MaterialReference(id = value, name = null)
		}

	var materialName: String?
		get() = material?.name
		set(value) { material = MaterialReference(name = value, id = null) }

	override fun assemble(): IItemDefinition {
		return MaterialItemDefinition(
			descriptionData = descriptionData,
			itemName = itemName,
			price = price,
			rarity = rarity,
			category = category,
			inventoryIcon = inventoryIcon,
			itemTags = itemTags,
			learnBlueprintsOnPickup = learnBlueprintsOnPickup,
			maxStack = maxStack,
			eventCategory = eventCategory,
			consumeOnPickup = consumeOnPickup,
			pickupQuestTemplates = pickupQuestTemplates,
			tooltipKind = tooltipKind,
			twoHanded = twoHanded,
			radioMessagesOnPickup = radioMessagesOnPickup,
			fuelAmount = fuelAmount,

			material = checkNotNull(material) { "Material is null (either 'materialId' or 'materialName' should be present, or 'material' itself)" },

			json = enrollMap(json),
		)
	}
}
